#ifndef LS_GS
#define LS_GS
#include "ls_names.h"
#include LS_MATRIX_H
#include LS_ARRAYU_H

// modifizierte Gram-Schmidt-Orthogonalisierung

class ls_GS
{ protected:
  ls_Matrix A, F;                 // Matrix und orthog. Matrix
  ls_arrayU<ls_REAL> R;           // Dreiecksfeld
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name, *R_name;
  ls_REAL eps;
  int rc;                         // Rckkehrwert nach Faktorisierung
  ls_GS(char* ="ls_GS");
  ls_GS(ls_Matrix &, ls_REAL =0., char* ="ls_GS");
                                  // Matrix-bernahme (move-Konstruktor)
                                  // Faktorisierung (mit Regularisierung)
  ls_GS(ls_GS &);
  ls_GS& swap(ls_GS &);
  unsigned char good()const{ return !rc;} // Erfolgssignal
  const ls_GS& operator=(const ls_GS &);
  const ls_GS& solve(ls_Vector &x, const ls_Vector &b) const;
                                  // Gleichungslser
  ls_UINT post_iteration(ls_Vector &x, ls_Vector &b) const;
                                  // Nachiteration
  ls_Vector residuum(const ls_Vector &x, const ls_Vector &b) const;
  ls_Vector Qx(const ls_Vector &x) const; // Q*x
  ls_Vector xQ(const ls_Vector &x) const; // x*Q
  ls_Vector Rx(const ls_Vector &x) const; // R*x
  ls_Vector xR(const ls_Vector &x) const; // x*R
  const ls_GS& write_row(ostream &) const;
  ls_GS& read_row(istream &);
  const ls_GS& write_column(ostream &) const;
  ls_GS& read_column(istream &);
  const ls_GS& operator>> (char *) const;
  ls_GS& operator<< (char *);
};
#ifndef LS_LIB
#include LS_GS_C
#endif
#endif
