#ifndef LS_INV
#define LS_INV
#include "ls_names.h"
#include LS_MATRIX_H

class ls_INV
{ protected:
  ls_Matrix A, F;                   // Matrix und Inverse
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name;
  ls_REAL eps;                      // Genauigkeitsschranke
  int rc;                           // Rckkehrwert nach Invertierung
  ls_INV(char* ="ls_INV");
  ls_INV(ls_Matrix &, ls_REAL = 0., char* ="ls_INV");
                                    // Matrix-bernahme (move-Konstruktor)
                                    // Invertierung ohne Pivotisierung
  ls_INV(ls_INV &);                 // move-Konstruktor
  unsigned char good()const{ return !rc;} // Erfolgssignal
  ls_INV& swap(ls_INV &);
  const ls_INV& operator=(const ls_INV &);
  const ls_INV& solve(ls_Vector &x, const ls_Vector &b) const;
                                    // Gleichungslser
  ls_UINT post_iteration(ls_Vector &x, ls_Vector &b) const;
                                    // Nachiteration
  ls_Vector residuum(const ls_Vector &x, const ls_Vector &b) const;
  ls_Vector Fx(const ls_Vector &x) const; // F*x
  ls_Vector xF(const ls_Vector &x) const; // x*F
  void remove(ls_UINT, ls_UINT);    // Zeile und Spalte entfernen
  void append(ls_array1<ls_REAL> &, ls_array1<ls_REAL> &);
                                    // Zeile/Spalte anhngen
  const ls_INV& write_row(ostream &) const;
  ls_INV& read_row(istream &);
  const ls_INV& write_column(ostream &) const;
  ls_INV& read_column(istream &);
  const ls_INV& operator>> (char *) const;
  ls_INV& operator<< (char *);
};
#ifndef LS_LIB
#include LS_INV_C
#endif
#endif
