#ifndef LS_INV_COLUMN
#define LS_INV_COLUMN
#include "ls_names.h"
#include LS_MATRIX_H

class ls_INV_column
{ protected:
  ls_Matrix A, F;                   // Matrix und Inverse
  ls_array1<ls_UINT> ind;           // Indexfeld
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name, *ind_name;
  ls_REAL eps;                      // Genauigkeitsschranke
  int rc;                           // Rckkehrwert nach Invertierung
  ls_INV_column(char* ="ls_INV_column");
  ls_INV_column(ls_Matrix &, ls_REAL = 0., char* ="ls_INV_column");
                                    // Matrix-bernahme (move-Konstruktor)
                                    // Invertierung mit Spalten-Pivotisierung
  ls_INV_column(ls_INV_column &);   // move-Konstruktor
  unsigned char good()const{ return !rc;} // Erfolgssignal
  ls_INV_column& swap(ls_INV_column &);
  const ls_INV_column& operator=(const ls_INV_column &);
  const ls_INV_column& solve(ls_Vector &x, const ls_Vector &b) const;
                                    // Gleichungslser
  ls_UINT post_iteration(ls_Vector &x, ls_Vector &b) const;
                                    // Nachiteration
  ls_Vector residuum(const ls_Vector &x, const ls_Vector &b) const;
  ls_Vector Fx(const ls_Vector &x) const; // F*x
  ls_Vector xF(const ls_Vector &x) const; // x*F
  const ls_INV_column& write_row(ostream &) const;
  ls_INV_column& read_row(istream &);
  const ls_INV_column& write_column(ostream &) const;
  ls_INV_column& read_column(istream &);
  const ls_INV_column& operator>> (char *) const;
  ls_INV_column& operator<< (char *);
};
#ifndef LS_LIB
#include LS_INVCOLUMN_C
#endif
#endif
