#ifndef LS_INV_DIAGONAL
#define LS_INV_DIAGONAL
#include "ls_names.h"
#include LS_MATRIX_H

class ls_INV_diagonal
{ protected:
  ls_Matrix A, F;                   // Matrix und Inverse
  ls_array1<ls_UINT> ind;
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name, *ind_name;
  ls_REAL eps;                      // Genauigkeitsschranke
  int rc;                           // Rckkehrwert nach Invertierung
  ls_INV_diagonal(char* ="ls_INV_diagonal");
  ls_INV_diagonal(ls_Matrix &, ls_REAL = 0., char* ="ls_INV_diagonal");
                                    // Matrix-bernahme (move-Konstruktor)
                                    // Invertierung mit Diagonal-Pivotisierung
  ls_INV_diagonal(ls_INV_diagonal &);           // move-Konstruktor
  unsigned char good()const{ return !rc;} // Erfolgssignal
  ls_INV_diagonal& swap(ls_INV_diagonal &);
  const ls_INV_diagonal& operator=(const ls_INV_diagonal &);
  const ls_INV_diagonal& solve(ls_Vector &x, const ls_Vector &b) const;
                                    // Gleichungslser
  ls_UINT post_iteration(ls_Vector &x, ls_Vector &b) const;
                                    // Nachiteration
  ls_Vector residuum(const ls_Vector &x, const ls_Vector &b) const;
  ls_Vector Fx(const ls_Vector &x) const; // F*x
  ls_Vector xF(const ls_Vector &x) const; // x*F
  const ls_INV_diagonal& write_row(ostream &) const;
  ls_INV_diagonal& read_row(istream &);
  const ls_INV_diagonal& write_column(ostream &) const;
  ls_INV_diagonal& read_column(istream &);
  const ls_INV_diagonal& operator>> (char *) const;
  ls_INV_diagonal& operator<< (char *);
};
#ifndef LS_LIB
#include LS_INVDIAGONAL_C
#endif
#endif
