#ifndef LS_INV_ROW
#define LS_INV_ROW
#include "ls_names.h"
#include LS_MATRIX_H

class ls_INV_row
{ protected:
  ls_Matrix A, F;                   // Matrix und Inverse
  ls_array1<ls_UINT> ind;           // Indexfeld
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name, *ind_name;
  ls_REAL eps;                      // Genauigkeitsschranke
  int rc;                           // Rckkehrwert nach Invertierung
  ls_INV_row(char* ="ls_INV_row");
  ls_INV_row(ls_Matrix &, ls_REAL = 0., char* ="ls_INV_row");
                                    // Matrix-bernahme (move-Konstruktor)
                                    // Invertierung mit Zeilen-Pivotisierung
  ls_INV_row(ls_INV_row &);   // move-Konstruktor
  unsigned char good()const{ return !rc;} // Erfolgssignal
  ls_INV_row& swap(ls_INV_row &);
  const ls_INV_row& operator=(const ls_INV_row &);
  const ls_INV_row& solve(ls_Vector &x, const ls_Vector &b) const;
                                    // Gleichungslser
  ls_UINT post_iteration(ls_Vector &x, ls_Vector &b) const;
                                    // Nachiteration
  ls_Vector residuum(const ls_Vector &x, const ls_Vector &b) const;
  ls_Vector Fx(const ls_Vector &x) const; // F*x
  ls_Vector xF(const ls_Vector &x) const; // x*F
  const ls_INV_row& write_row(ostream &) const;
  ls_INV_row& read_row(istream &);
  const ls_INV_row& write_column(ostream &) const;
  ls_INV_row& read_column(istream &);
  const ls_INV_row& operator>> (char *) const;
  ls_INV_row& operator<< (char *);
};
#ifndef LS_LIB
#include LS_INVROW_C
#endif
#endif
