#ifndef LS_INV_TOTAL
#define LS_INV_TOTAL
#include "ls_names.h"
#include LS_MATRIX_H

class ls_INV_total
{ protected:
  ls_Matrix A, F;                   // Matrix und Inverse
  ls_array1<ls_UINT> indr, indc;    // Indexfelder
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name, *indr_name, *indc_name;
  ls_REAL eps;                      // Genauigkeitsschranke
  int rc;                           // Rckkehrwert nach Invertierung
  ls_INV_total(char* ="ls_INV_total");
  ls_INV_total(ls_Matrix &, ls_REAL = 0., char* ="ls_INV_total");
                                    // Matrix-bernahme (move-Konstruktor)
                                    // Invertierung mit Total-Pivotisierung
  ls_INV_total(ls_INV_total &);   // move-Konstruktor
  unsigned char good()const{ return !rc;} // Erfolgssignal
  ls_INV_total& swap(ls_INV_total &);
  const ls_INV_total& operator=(const ls_INV_total &);
  const ls_INV_total& solve(ls_Vector &x, const ls_Vector &b) const;
                                    // Gleichungslser
  ls_UINT post_iteration(ls_Vector &x, ls_Vector &b) const;
                                    // Nachiteration
  ls_Vector residuum(const ls_Vector &x, const ls_Vector &b) const;
  ls_Vector Fx(const ls_Vector &x) const; // F*x
  ls_Vector xF(const ls_Vector &x) const; // x*F
  const ls_INV_total& write_row(ostream &) const;
  ls_INV_total& read_row(istream &);
  const ls_INV_total& write_column(ostream &) const;
  ls_INV_total& read_column(istream &);
  const ls_INV_total& operator>> (char *) const;
  ls_INV_total& operator<< (char *);
};
#ifndef LS_LIB
#include LS_INVTOTAL_C
#endif
#endif
