#ifndef LS_LDLT
#define LS_LDLT
#include "ls_names.h"
#include LS_SMATRIX_H

class ls_LDLT
{ protected:
  ls_sMatrix A, F;
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name;
  ls_REAL eps;
  int rc;       // Rckkehrwert nach Faktorisierung
  ls_LDLT(char* ="ls_LDLT");
  ls_LDLT(ls_sMatrix&, ls_REAL =0.,char* ="ls_LDLT");
                // Matrix-bernahme (move-Konstruktor)
                // und LDLT-Faktorisierung (mit Regularisierung)
  ls_LDLT(ls_LDLT &);
  unsigned char good()const{ return !rc;} // Erfolgssignal
  ls_LDLT& swap(ls_LDLT &);
  const ls_LDLT& operator=(const ls_LDLT &);
  const ls_LDLT& solve(ls_Vector &x, const ls_Vector &b) const;
                                  // Gleichungslser
  ls_UINT post_iteration(ls_Vector &x, ls_Vector &b) const;
                                  // Nachiteration
  ls_Vector residuum(const ls_Vector &x, 
                     const ls_Vector &b) const;
  ls_Vector Lx(const ls_Vector &x) const; 
                // L*x (L: Cholesky-Faktor)
  ls_Vector xL(const ls_Vector &x) const; 
                // x*L (L: Cholesky-Faktor)
  const ls_LDLT& write_row(ostream &) const;
  ls_LDLT& read_row(istream &);
  const ls_LDLT& write_column(ostream &) const;
  ls_LDLT& read_column(istream &);
  const ls_LDLT& operator>> (char *) const;
  ls_LDLT& operator<< (char *);
};
#ifndef LS_LIB
#include LS_LDLT_C
#endif
#endif
