#ifndef LS_LDLT_DIAGONAL
#define LS_LDLT_DIAGONAL
#include "ls_names.h"
#include LS_SMATRIX_H

class ls_LDLT_diagonal
{ protected:
  ls_sMatrix A, F;                // Matrix und Faktorisierung
  ls_array1<ls_UINT> ind;         // wahre Diagonal-Indices
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name, *ind_name;
  ls_REAL eps;
  int rc;                 // Rckkehrwert nach Faktorisierung
  ls_LDLT_diagonal(char* ="ls_LDLT_diagonal");
  ls_LDLT_diagonal(ls_sMatrix &, ls_REAL =0., 
                   char* ="ls_LDLT_diagonal");
                          // Matrix-bernahme (move-Konstruktor)
                          // LDLT-Faktor. mit Diagonal-Pivot.
  unsigned char good()const{ return !rc;} // Erfolgssignal
  ls_LDLT_diagonal(ls_LDLT_diagonal &);
  ls_LDLT_diagonal& swap(ls_LDLT_diagonal &);
  const ls_LDLT_diagonal& operator=(const ls_LDLT_diagonal&);
  const ls_LDLT_diagonal& solve(ls_Vector &x, 
                                const ls_Vector &b) const;
                                  // Gleichungslser
  ls_UINT post_iteration(ls_Vector &, ls_Vector &) const;
                                  // Nachiteration
  ls_Vector residuum(const ls_Vector &x, 
                     const ls_Vector &b) const;
  ls_Vector Lx(const ls_Vector &x) const; 
                         // L*x (L: Cholesky-Faktor)
  ls_Vector xL(const ls_Vector &x) const; 
                         // x*L (L: Cholesky-Faktor)
  const ls_LDLT_diagonal& write_row(ostream &) const;
  ls_LDLT_diagonal& read_row(istream &);
  const ls_LDLT_diagonal& write_column(ostream &) const;
  ls_LDLT_diagonal& read_column(istream &);
  const ls_LDLT_diagonal& operator>> (char *) const;
  ls_LDLT_diagonal& operator<< (char *);
};
#ifndef LS_LIB
#include LS_LDLTDIAGONAL_C
#endif
#endif
