#ifndef LS_LU_COLUMN
#define LS_LU_COLUMN
#include "ls_names.h"
#include LS_MATRIX_H

class ls_LU_column
{ protected:
  ls_Matrix A, F;
  ls_array1<ls_UINT> ind;
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name, *ind_name;
  ls_REAL eps;           // Genauigkeitsschranke
  int rc;                // Rckkehrwert nach Faktorisierung
  ls_LU_column(char* ="ls_LU_column");
  ls_LU_column(ls_Matrix &, ls_REAL =0., char* ="ls_LU_column");
                         // Matrix-bernahme (move-Konstruktor)
                         // LU-Faktor. mit Spalten-Pivotisierung
  unsigned char good()const{ return !rc;}// Erfolgssignal
  ls_LU_column(ls_LU_column &);    // move-Konstruktor
  ls_LU_column& swap(ls_LU_column &);
  const ls_LU_column& operator=(const ls_LU_column &);
  const ls_LU_column& solve(ls_Vector &x, 
                            const ls_Vector &b) const;
                         // Gleichungslser
  ls_UINT post_iteration(ls_Vector &, ls_Vector &) const;
                         // Nachiteration
  ls_Vector residuum(const ls_Vector &x, 
                     const ls_Vector &b) const;
  ls_Vector Lx(const ls_Vector &x) const; // L*x
  ls_Vector xL(const ls_Vector &x) const; // x*L
  ls_Vector Ux(const ls_Vector &x) const; // U*x
  ls_Vector xU(const ls_Vector &x) const; // x*U
  const ls_LU_column& write_row(ostream &) const;
  ls_LU_column& read_row(istream &);
  const ls_LU_column& write_column(ostream &) const;
  ls_LU_column& read_column(istream &);
  const ls_LU_column& operator>> (char *) const;
  ls_LU_column& operator<< (char *);
};
#ifndef LS_LIB
#include LS_LUCOLUMN_C
#endif
#endif
