#ifndef LS_LU_TOTAL
#define LS_LU_TOTAL
#include "ls_names.h"
#include LS_MATRIX_H

class ls_LU_total
{ protected:
  ls_Matrix A, F;
  ls_array1<ls_UINT> indr, indc;
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name, *indr_name, *indc_name;
  ls_REAL eps;                 // Genauigkeitsschranke
  int rc;                      // Rckkehrwert nach Faktorisierung
  ls_LU_total(char* ="ls_LU_total");
  ls_LU_total(ls_Matrix &, ls_REAL =0., char* ="ls_LU_total");
                               // Matrix-bernahme (move-Konstruktor)
                               // LU-Fakt. mit Total-Pivotisierung
  unsigned char good()const{ return !rc;} // Erfolgssignal
  ls_LU_total(ls_LU_total &);
  ls_LU_total& swap(ls_LU_total &);
  const ls_LU_total& operator=(const ls_LU_total &);
  const ls_LU_total& solve(ls_Vector &x, const ls_Vector &b) const;
                                  // Gleichungslser
  ls_UINT post_iteration(ls_Vector &, ls_Vector &) const;
                                  // Nachiteration
  ls_Vector residuum(const ls_Vector &x, const ls_Vector &b) const;
  ls_Vector Lx(const ls_Vector &x) const; // L*x
  ls_Vector xL(const ls_Vector &x) const; // x*L
  ls_Vector Ux(const ls_Vector &x) const; // U*x
  ls_Vector xU(const ls_Vector &x) const; // x*U
  const ls_LU_total& write_row(ostream &) const;
  ls_LU_total& read_row(istream &);
  const ls_LU_total& write_column(ostream &) const;
  ls_LU_total& read_column(istream &);
  const ls_LU_total& operator>> (char *) const;
  ls_LU_total& operator<< (char *);
};
#ifndef LS_LIB
#include LS_LUTOTAL_C
#endif
#endif
