#ifndef LS_MATRIX
#define LS_MATRIX
#include "ls_names.h"
#include LS_VECTOR_H
#include LS_ARRAY2_H

class ls_Matrix: public ls_array2<ls_REAL>
{ public:
  ls_Matrix(ls_UINT =0, ls_UINT =0, char* ="ls_Matrix");
  ls_Matrix(ls_Matrix &);
  const ls_Matrix& operator=(const ls_Matrix &);
  ls_Vector row(ls_UINT i)const
  { ls_Vector u(n); get_row(u,i); return u;}
  ls_Vector column(ls_UINT j)const
  { ls_Vector u(n); get_column(u,0,j); return u;}
  ls_Vector upper_diagonal(ls_UINT j)const
  { ls_Vector u(n); get_diagonal(u,0,j); return u;}
  ls_Vector lower_diagonal(ls_UINT i)const
  { ls_Vector u(n); get_diagonal(u,i,0); return u;}
  ls_Matrix& operator+=(const ls_Matrix &);    //A=A+B
  ls_Matrix operator-(const ls_Matrix &)const; //A-B
  ls_Matrix& operator-=(const ls_Matrix &);    //A=A-B
  ls_Matrix operator+(const ls_Matrix &) const;//A+B
  ls_Matrix operator*(const ls_Matrix &) const;//A*B
  ls_Vector operator*(const ls_Vector &) const;//A*x
  ls_Matrix operator*(ls_REAL) const;          //A*s
  ls_Matrix& operator*=(ls_REAL);              //A=A*s
  ls_UINT solve(ls_Vector &x, ls_Vector &b) const;//cg-Verfahren

};
ls_Matrix operator*(ls_REAL, const ls_Matrix &);  // s*A
ls_Vector operator*(const ls_Vector &, const ls_Matrix &);// x*A
#ifndef LS_LIB
#include LS_MATRIX_C
#endif
#endif
