#ifndef LS_QR
#define LS_QR
#include "ls_names.h"
#include LS_MATRIX_H

class ls_QR
{ protected:
  ls_Matrix A, F;        // Matrix und QR-Faktorisierung
  ls_array1<ls_REAL> gamma, rho;  // Hilfsfelder
  char ONAME[ls_len];
  public:
  char *name, *A_name, *F_name, *gamma_name, *rho_name;
  ls_REAL eps;
  int rc;                // Rckkehrwert nach Faktorisierung
  ls_QR(char* ="ls_QR");
  ls_QR(ls_Matrix &, ls_REAL =0., char* ="ls_QR");
                         // Matrix-bernahme (move-Konstruktor)
                         // Faktorisierung (mit Regularisierung)
  ls_QR(ls_QR &);
  ls_QR& swap(ls_QR &);
  unsigned char good()const{ return !rc;} // Erfolgssignal
  const ls_QR& operator=(const ls_QR &);
  const ls_QR& solve(ls_Vector &x, const ls_Vector &b) const;
                         // Gleichungslser
  ls_UINT post_iteration(ls_Vector &x, ls_Vector &b) const;
                         // Nachiteration
  ls_Vector residuum(const ls_Vector &x, 
                     const ls_Vector &b) const;
  ls_Vector Qx(const ls_Vector &x) const; // Q*x
  ls_Vector xQ(const ls_Vector &x) const; // x*Q
  ls_Vector Rx(const ls_Vector &x) const; // R*x
  ls_Vector xR(const ls_Vector &x) const; // x*R
  const ls_QR& write_row(ostream &) const;
  ls_QR& read_row(istream &);
  const ls_QR& write_column(ostream &) const;
  ls_QR& read_column(istream &);
  const ls_QR& operator>> (char *) const;
  ls_QR& operator<< (char *);
};
#ifndef LS_LIB
#include LS_QR_C
#endif
#endif
