#ifndef LS_VECTOR
#define LS_VECTOR
#include "ls_names.h"
#include LS_ARRAY1_H

class ls_Matrix; class ls_sMatrix;
class ls_Vector: public ls_array1<ls_REAL>
{ public:
  ls_REAL eps;
  ls_Vector(ls_UINT =0, char* ="ls_Vector");
  ls_Vector(ls_Vector &);
  ls_Vector(ls_REAL*, ls_UINT, char* ="ls_Vector");
  ~ls_Vector(){}
  const ls_Vector& operator=(const ls_Vector &);
  ls_Vector operator-() const;                 //-x
  ls_Vector operator*(ls_REAL) const;          //x*s
  ls_Vector& operator*=(ls_REAL);              //x=x*s
  ls_Vector operator+(const ls_Vector &)const; //x+y
  ls_Vector operator-(const ls_Vector &)const; //x-y
  ls_Vector& operator+=(const ls_Vector &);    //x=x+y
  ls_Vector& operator-=(const ls_Vector &);    //x=x-y
  ls_REAL operator*(const ls_Vector &)const;   //x*y
  ls_Matrix dyad(const ls_Vector &)const;      //dyad.
  ls_sMatrix dyad()const;                      //dyad.
};
ls_Vector operator*(ls_REAL, const ls_Vector &); //s*x
#ifndef LS_LIB
#include LS_VECTOR_C
#endif
#endif
