#ifndef LS_ARRAY1M
#define LS_ARRAY1M
#include "ls_names.h"
#include LS_ARRAY1_H

template <class T>
struct array1M{ ls_UINT l; T *f;};

template <class T>
class ls_array1M          // Reihung Eindimensionaler Felder
{ protected:
  array1M<T> *a;          // Datenfeld
  ls_UINT   n;            // Dimension von a
  char ONAME[ls_len];
  void set_data(array1M<T> *aa=NULL,ls_UINT nn=0){ a=aa; n=nn;}
  public:
  char *name;             // Objektname
  ls_array1M(ls_UINT =0, char* ="ls_array1M");
  ls_array1M(ls_array1M<T> &);
  ~ls_array1M();
  ls_array1M<T>& swap(ls_array1M<T> &);
  ls_UINT number_of_arrays() const{ return n;}
  ls_UINT length(ls_UINT i) const{ return (a+i)->l;}
                          // Lnge des i-ten Feldes
  array1M<T>* asArray()const{ return a;}
  T* operator[](ls_UINT i){ return (a+i)->f;}
                        // indizierter Zugriff auf das i-te Feld
  const ls_array1M<T>& operator=(const ls_array1M<T>&);
  ls_array1M<T>& put_array(const ls_array1<T>&v, ls_UINT i);
                          // Eingabe des i-ten Feldes
  ls_array1M<T>& put(const T*, ls_UINT l, ls_UINT i);
                          // Eingabe eines Feldes als i-tes Feld
  ls_array1M<T>& put(T, ls_UINT); 
                          // Eingabe eines Wertes als i-tes Feld
  const ls_array1M<T>& get_array(ls_array1<T>&v, 
                                 ls_UINT i) const;
                          // Ausgabe des i-ten Feldes
  ls_array1M<T>& remove_array(ls_UINT i);
                                  // i-tes Feld entfernen
  ls_array1M<T>& remove();        // alle Felder entfernen
  const ls_array1M<T>& write(ostream &) const;
  ls_array1M<T>& read(istream &);
  const ls_array1M<T>& operator>> (char *) const;
  ls_array1M<T>& operator<< (char *);
};
#ifndef LS_LIB
#include LS_ARRAY1M_C
#endif
#endif
