#ifndef LS_ARRAY2
#define LS_ARRAY2
#include "ls_names.h"
#include LS_ARRAY1_H

template <class T>
class ls_array2: public ls_array1<T>      // Zweidim. Felder
{ protected:
  ls_UINT m, n;
  void set_data(ls_UINT mm=0, ls_UINT nn=0){ m=mm; n=nn;}
  public:
  ls_array2(ls_UINT =0, ls_UINT =0, char* ="ls_array2");
  ls_array2(ls_array2<T> &);                // move-Konstruktor
  ls_array2<T>(T*, ls_UINT, ls_UINT, char* ="ls_array2");
                                            // Feld-bernahme
  ~ls_array2(){}
  ls_array2<T>& swap(ls_array2<T> &);
  T* operator[](ls_UINT i) const;         // indizierter Zugriff
  ls_UINT number_of_rows() const{ return m;}
  ls_UINT number_of_columns() const{ return n;}
  const ls_array2<T>& operator=(const ls_array2<T> &);
  ls_array2<T>& put(T, ls_UINT, ls_UINT);   // Elementeingabe
  ls_array2<T>& put_row(const ls_array1<T>&, ls_UINT, 
                        ls_UINT =0);
  ls_array2<T>& put_row(T, ls_UINT, ls_UINT =0);
  ls_array2<T>& put_column(const ls_array1<T>&, ls_UINT, 
                           ls_UINT);
  ls_array2<T>& put_column(T, ls_UINT, ls_UINT);
  ls_array2<T>& put_diagonal(const ls_array1<T> &,
                             ls_UINT =0, ls_UINT =0);
  ls_array2<T>& put_diagonal(T, ls_UINT =0, ls_UINT =0);
  ls_array2<T>& put_array(const ls_array2<T> &,
                             ls_UINT =0, ls_UINT =0);
  ls_array2<T>& put_array(T, ls_UINT =0, ls_UINT =0);
  T get(ls_UINT, ls_UINT) const;          // Element-Ausgabe
  const ls_array2<T>& get_row(ls_array1<T>&,
                              ls_UINT, ls_UINT =0) const;
  const ls_array2<T>& get_column(ls_array1<T>&,
                              ls_UINT, ls_UINT) const;
  const ls_array2<T>& get_diagonal(ls_array1<T>&,
                              ls_UINT =0, ls_UINT =0) const;
  const ls_array2<T>& get_array(ls_array2<T>&,
                              ls_UINT =0, ls_UINT =0) const;
  ls_array2<T>& append_row(ls_UINT =1);   // Null-Zeilen anhng.
  ls_array2<T>& append_column(ls_UINT =1);// Null-Spalten anhng.
  ls_array2<T>& append_array(ls_UINT =1, ls_UINT =1);
                                          // Null-Feld anhngen
  ls_array2<T>& remove_row(ls_UINT i);    // Zeile streichen
  ls_array2<T>& remove_column(ls_UINT i); // Spalte streichen
  ls_array2<T>& remove();                 // Datenfeld streichen
  ls_array2<T>& swap_row(ls_UINT, ls_UINT);// Zeilentausch
  ls_array2<T>& swap_column(ls_UINT, ls_UINT);// Spaltentausch
  const ls_array2<T>& write_row(ostream &) const;
  ls_array2<T>& read_row(istream &);
  const ls_array2<T>& write_column(ostream &) const;
  ls_array2<T>& read_column(istream &);
  const ls_array2<T>& operator>>(char *)const;// Zeilen in Datei
  ls_array2<T>& operator<<(char *);           // Zeilen aus Datei
};
#ifndef LS_LIB
#include LS_ARRAY2_C
#endif
#endif
