//: $CC -DLS_LIB -c $file
#ifndef LS_BMATRIXC
#define LS_BMATRIXC
#include "ls_names.h"
#include LS_BMATRIX_H

ls_bMatrix::ls_bMatrix(ls_UINT nn,char *nam):
ls_array1M<ls_REAL>(nn,nam){}

ls_bMatrix::ls_bMatrix(ls_bMatrix &A):ls_array1M<ls_REAL>(A){}

const ls_bMatrix& ls_bMatrix::operator=(const ls_bMatrix &A)
{ ls_array1M<ls_REAL>::operator=(A); return *this;}

ls_Vector ls_bMatrix::operator*(ls_Vector &u)
{ ls_UINT l, ll=1, nn=u.dimension();
  ls_array1<double> x(nn), v(nn);
  ls_Vector y(nn);
  double *ua=x.asArray(), *uu, *ue, *vv, *va=v.asArray();
  ls_REAL s, *c, *yy=y.asArray();
  for(l=0, c=u.asArray(); l<nn; ua[l]=c[l], l++);
  array1M<ls_REAL> *aa=a, *ae=aa+n;
  if((l=aa->l)==1)
    for(s=*(aa->f), vv=va, uu=ua, ue=ua+nn; uu<ue; 
         *vv=*uu*s, uu++, vv++);
  else
    for(c=aa->f, vv=va, uu=ua, ue=uu+l; uu<ue; 
         *vv=*c*(*uu), vv++,c++,uu++);
  for (aa++; aa<ae; aa++, ll++)
    if((l=aa->l)==1)
      for(s=*(aa->f), uu=ua, ue=uu+nn-ll, vv=va; uu<ue;
          *vv+=uu[ll]*s, vv[ll]+=*uu*s, uu++, vv++);
    else
      for(c=aa->f, uu=ua, ue=uu+l, vv=va; uu<ue;
          *vv+=*c*uu[ll], vv[ll]+=*c*(*uu), vv++, uu++, c++);

  for(l=0; l<nn; yy[l]=(ls_REAL)(va[l]), l++);
  return y;
}

ls_UINT ls_bMatrix::solve(ls_Vector &x, ls_Vector &b)
{ b-=(*this)*x;
  ls_Vector p, w; p=b; w=(*this)*p;
  ls_REAL s, bb=b*b, wp=w*p, bbn, eps=x.eps;
  ls_UINT it=0, nn=x.dimension(), rep=nn*nn;
  while(!((bb+wp)<eps)&&(it++<rep))
  { s=bb/wp; b-=s*w; x+=s*p; bbn=b*b; p=b+(bbn/bb)*p;
    w=(*this)*p; wp=w*p; bb=bbn;
  }
  return it;
}
#endif
