// symmetrische Matrix (nur oberes Dreieck)

#ifndef LS_SMATRIX
#define LS_SMATRIX
#include "ls_names.h"
#include LS_VECTOR_H
#include LS_ARRAYU_H

class ls_Matrix;

class ls_sMatrix: public ls_arrayU<ls_REAL>
{ public:
  ls_sMatrix(ls_UINT =0, char* ="ls_sMatrix");
  ls_sMatrix(ls_sMatrix &);
  ls_Vector row(ls_UINT i)const
  { ls_Vector u(n); get_row(u,i,i+1), get_column(u,0,i); 
    return u;}
  ls_Vector diagonal(ls_UINT j)const
  { ls_Vector u(n); get_diagonal(u,0,j); return u;}
  const ls_sMatrix& operator=(const ls_sMatrix &); //A=B
  ls_sMatrix& operator+=(const ls_sMatrix&);       //A=A+B
  ls_sMatrix operator-(const ls_sMatrix&) const;   //A-B
  ls_sMatrix& operator-=(const ls_sMatrix&);       //A=A-B
  ls_sMatrix operator+(const ls_sMatrix&) const;   //A+B
  ls_sMatrix& operator*=(ls_REAL);                 //A=A*s
  ls_Vector operator*(const ls_Vector&) const;     //A*x
  ls_sMatrix operator*(ls_REAL) const;             //A*s
  ls_Matrix operator*(const ls_sMatrix &) const;   //A*B
  ls_UINT solve(ls_Vector &x, ls_Vector &b);     //cg-Verfahren
};
ls_sMatrix operator*(ls_REAL, const ls_sMatrix&);  //s*A
#include LS_MATRIX_H
#ifndef LS_LIB
#include LS_SMATRIX_C
#endif
#endif
