// obere Dreiecksmatrix

#ifndef LS_UMATRIX
#define LS_UMATRIX
#include "ls_names.h"
#include LS_VECTOR_H
#include LS_ARRAYU_H

class ls_Matrix;

class ls_uMatrix: public ls_arrayU<ls_REAL>
{ public:
  ls_uMatrix(ls_UINT =0, char* ="ls_uMatrix");
  ls_uMatrix(ls_uMatrix &);
  ls_Vector row(ls_UINT i)const
  { ls_Vector u(n); get_row(u,i,i); return u;}
  ls_Vector column(ls_UINT j)const
  { ls_Vector u(n); get_column(u,0,j); return u;}
  ls_Vector diagonal(ls_UINT j)const
  { ls_Vector u(n); get_diagonal(u,0,j); return u;}
  const ls_uMatrix& operator=(const ls_uMatrix &); //A=B
  ls_uMatrix& operator+=(const ls_uMatrix&);       //A=A+B
  ls_uMatrix operator-(const ls_uMatrix&) const;   //A-B
  ls_uMatrix& operator-=(const ls_uMatrix&);       //A=A-B
  ls_uMatrix operator+(const ls_uMatrix&) const;   //A+B
  ls_uMatrix& operator*=(ls_REAL);                 //A=A*s
  ls_Vector operator*(const ls_Vector&) const;     //A*x
  ls_uMatrix operator*(ls_REAL) const;             //A*s
  ls_Matrix operator*(const ls_uMatrix &) const;   //A*B
  ls_UINT solve(ls_Vector &, ls_Vector &);       //cg-Verfahren
  void backward(ls_Vector &, ls_Vector &);     // Rckwrtseins.
};
ls_uMatrix operator*(ls_REAL, const ls_uMatrix&);  //s*A
ls_Vector operator*(const ls_Vector&, const ls_uMatrix&); //x*A
#include LS_MATRIX_H
#ifndef LS_LIB
#include LS_UMATRIX_C
#endif
#endif
